#define dprintf printf

#ifndef INCLUDEUCHAR
#ifndef uchar
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define ushort  unsigned short
#endif
#endif
/*
 * OggDec
 *

 uma maravilha dos codigos
  que voce faz somente o servio uma vez e nao perde mais
 tempo
 com isto

 Pode crer

 *
 *
 *
 *
 *
 * Este novo decoder  mais limpo e tem mais funcoes disponiveis e
 * aparentemente  mais facil de usar doque aquele la
 *
 * Mas da para implementar este de outra forma mesmo
 *
 * Basta verificar de que jeito isto funciona
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 * * This program is distributed under the GNU General Public License,
 * version 2. A copy of this license is included with this source.
 * Copyright 2002, Michael Smith <msmith@labyrinth.net.au>
 */
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
// #include <getopt.h>
#include <errno.h>
#include <string.h>

#if defined(_WIN32) || defined(__EMX__) || defined(__WATCOMC__)
#include <fcntl.h>
#include <io.h>
#endif


#define VERSIONSTRING "OggDec 1.0\n"

static int quiet = 0;
static int bits = 16;
static int endian = 0;
static int raw = 0;
static int sign = 1;
unsigned char headbuf[44];	/* The whole buffer */


size_t fread_unbuffered(void *ptr, size_t size, size_t nelem, FILE *stream);
size_t fwrite_unbuffered(const void *ptr, size_t size, size_t nelem, FILE *stream);




#define WRITE_U32(buf, x) *(buf)     = (unsigned char)((x)&0xff);\
                          *((buf)+1) = (unsigned char)(((x)>>8)&0xff);\
                          *((buf)+2) = (unsigned char)(((x)>>16)&0xff);\
                          *((buf)+3) = (unsigned char)(((x)>>24)&0xff);

#define WRITE_U16(buf, x) *(buf)     = (unsigned char)((x)&0xff);\
                          *((buf)+1) = (unsigned char)(((x)>>8)&0xff);

/*
 * Some of this based on ao/src/ao_wav.c
 */
int
write_prelim_header (FILE * out, int channels, int samplerate)
{

	int knownlength = 0;

	unsigned int size = 0x7fffffff;
	// int channels = 2;
	// int samplerate = 44100;
	int bytespersec = channels * samplerate * bits / 8;
	int align = channels * bits / 8;
	int samplesize = bits;

	if (knownlength)
		size = (unsigned int) knownlength;

	memcpy (headbuf, "RIFF", 4);
	WRITE_U32 (headbuf + 4, size - 8);
	memcpy (headbuf + 8, "WAVE", 4);
	memcpy (headbuf + 12, "fmt ", 4);
	WRITE_U32 (headbuf + 16, 16);
	WRITE_U16 (headbuf + 20, 1);	/* format */
	WRITE_U16 (headbuf + 22, channels);
	WRITE_U32 (headbuf + 24, samplerate);
	WRITE_U32 (headbuf + 28, bytespersec);
	WRITE_U16 (headbuf + 32, align);
	WRITE_U16 (headbuf + 34, samplesize);
	memcpy (headbuf + 36, "data", 4);
	WRITE_U32 (headbuf + 40, size - 44);

	if (fwrite_unbuffered (headbuf, 1, 44, out) != 44)
	  {
	  
#ifdef NPRINTF
		  dprintf ("ERROR: Failed to write wav header: %s\n",
			   strerror (errno));
#endif
			   
		  return 1;
	  }

	return 0;
}

int
rewrite_header (FILE * out, unsigned int written)
{
__int64 _ftelli64_arab(FILE *stream);
int _fseeki64_arab(FILE *stream,__int64 offset,int origin);
	unsigned int length = written;

	length += 44;

	WRITE_U32 (headbuf + 4, length - 8);
	WRITE_U32 (headbuf + 40, length - 44);
	if (_fseeki64_arab (out, 0, SEEK_SET) != 0)
	  {
#ifdef NPRINTF
		  dprintf ("ERROR: Failed to seek on seekable file: %s\n",
			   strerror (errno));
#endif
			   
		  return 1;
	  }

	if (fwrite_unbuffered (headbuf, 1, 44, out) != 44)
	  {
#ifdef NPRINTF
		  dprintf ("ERROR: Failed to write wav header: %s\n",
			   strerror (errno));
#endif
		  return 1;
	  }
	return 0;
}
