﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace mp3dll
{
    public partial class equalizer : Form
    {

        /// <summary>
        /// main equalizer form
        /// </summary>
        public equalizer()
        {
            InitializeComponent();
        }

        int number = 1;//player selection

        private void equalizer_Load(object sender, EventArgs e)
        {
            StringBuilder settings = new StringBuilder(1000);
            MP3.GetSettings(number, "equalizer", settings, "0");

            if ("0" == settings.ToString())
            {
                MP3.EnableEqualizer(number, 0);
                equa.CheckState = CheckState.Unchecked;
            }
            else
            {
                MP3.EnableEqualizer(number, 1);
                equa.CheckState = CheckState.Checked;
            }

            MP3.GetSettings(number, "s60", settings, "5");
            s60.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s170", settings, "5");
            s170.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s310", settings, "5");
            s310.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s600", settings, "5");
            s600.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s1000", settings, "5");
            s1000.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s3000", settings, "5");
            s3000.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s6000", settings, "5");
            s6000.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s12000", settings, "5");
            s12000.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s14000", settings, "5");
            s14000.Value = int.Parse(settings.ToString());
            MP3.GetSettings(number, "s16000", settings, "5");
            s16000.Value = int.Parse(settings.ToString());

            MP3.EqualizerSettings(number,
                (s60.Value * 10),
                (s170.Value * 10),
                (s310.Value * 10),
                (s600.Value * 10),
                (s1000.Value * 10),
                (s3000.Value * 10),
                (s6000.Value * 10),
                (s12000.Value * 10),
                (s14000.Value * 10),
                (s16000.Value * 10));

            MP3.GetSettings(number, "pre", settings, "0");

            if ("0" == settings.ToString())
            {
                MP3.EnablePreamplifier(number, 0);
                pre.CheckState = CheckState.Unchecked;
            }
            else
            {
                MP3.EnablePreamplifier(number, 1);
                pre.CheckState = CheckState.Checked;
            }

            MP3.GetSettings(number, "pre_val", settings, "5");

            _pre.Value = int.Parse (settings.ToString ());

            MP3.PreamplifierValue(number, _pre.Value * 10);

            MP3.GetSettings(number, "double", settings, "0");

            if ("0" == settings.ToString())
            {
                MP3.DoubleBuffer (number, 0);
                double_.CheckState = CheckState.Unchecked;
            }
            else
            {
                MP3.DoubleBuffer(number, 1);
                double_.CheckState = CheckState.Checked;
            }

        }

        private void equa_MouseUp(object sender, MouseEventArgs e)
        {
            if (equa.CheckState == CheckState.Checked)
            {
                MP3.SaveSettings(number, "equalizer", "1");
                MP3.EnableEqualizer(number, 1);
            }
            else
            {
                MP3.SaveSettings(number, "equalizer", "0");
                MP3.EnableEqualizer(number, 0);
            }
        }

        private void equa_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void _pre_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "pre_val", _pre.Value.ToString ());

            

            MP3.PreamplifierValue(number, _pre.Value * 10);
        }

        private void pre_MouseUp(object sender, MouseEventArgs e)
        {
           

            if (pre.CheckState == CheckState .Checked )
            {
                MP3.SaveSettings(number, "pre", "1");
                MP3.EnablePreamplifier(number, 1);
                
            }
            else
            {
                MP3.SaveSettings(number, "pre", "0");
                MP3.EnablePreamplifier(number, 0);
            }
        }

        private void double__MouseUp(object sender, MouseEventArgs e)
        {
            if (double_.CheckState == CheckState.Checked)
            {
                MP3.SaveSettings(number, "double", "1");
                MP3.DoubleBuffer (number, 1);
            }
            else
            {
                MP3.SaveSettings(number, "double", "0");
                MP3.DoubleBuffer(number, 0);
            }
        }

        private void s60_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s60", s60.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));

        }

        private void s170_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s170", s170.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s310_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s310", s310.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s600_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s600", s600.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s1000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s1000", s1000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s3000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s3000", s3000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s6000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s6000", s6000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s12000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s12000", s12000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s14000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s14000", s14000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }

        private void s16000_Scroll(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "s16000", s16000.Value.ToString());

            MP3.EqualizerSettings(number,
     (s60.Value * 10),
     (s170.Value * 10),
     (s310.Value * 10),
     (s600.Value * 10),
     (s1000.Value * 10),
     (s3000.Value * 10),
     (s6000.Value * 10),
     (s12000.Value * 10),
     (s14000.Value * 10),
     (s16000.Value * 10));
        }
    }
}
